import fse from 'fs-extra'
import extend from 'extend'
import mkdirp from 'mkdirp'
import {saveHtml} from './controllers/Save'

import {
  Util,
  FileParser,
  config,
  fileUtils,
  fileAttr,
  cli,
  log,
  Page
} from './'

class Builder {

  constructor(root, folder, dest){
    this.pathToJson = fileUtils.concatPath(root, config.data.url)
    var files = fileAttr.filterLatestVersion(FileParser.getFiles(this.pathToJson, config.data.url), folder)
    files.forEach(function (file) {
      var json = fse.readJsonSync(file.path)
      var text = fse.readFileSync(fileUtils.concatPath(root, config.templates.url, json.abe_meta.template) + '.' + config.files.templates.extension, 'utf8')
      text = Util.removeDataList(text)
      var page = new Page(json.abe_meta.link, text, json, true)
      saveHtml(fileUtils.concatPath(root, dest + json.abe_meta.link), page.html)
      console.log(fileUtils.concatPath(root, dest + json.abe_meta.link))
    })
  }

}

if(process.env.ROOT && process.env.FOLDER && process.env.DEST){
  config.set({root: process.env.ROOT})
  var dest = process.env.DEST || 'tmp'
  new Builder(process.env.ROOT, process.env.FOLDER, dest)
}